# -*- coding: utf-8 -*-
import gtk
import os, marshal, base64

import WIDGET, child, GConf, Conf, i18n

_ = i18n.gettext()

class AskCloseAllTabDialog (WIDGET.WIDGET) :

	GCONF_CLIENT = None
	LIST_TAB = list()
	NOTEBOOK = None
	STATE = None

	def __init__ (self, ROOT, state) :
		handler = { \
			"on_ok"	: self.on_ok, \
			"on_cancel" : self.on_close, \
		}

		WIDGET.WIDGET.__init__( \
			self, "quit", ROOT, handler)

		self.WIDGET_SELF.set_title(_("Quit"))

		self.STATE = state

		if self.STATE.DATA.has_key("tab-list") :
			self.LIST_TAB = self.STATE.DATA["tab-list"]

		if self.STATE.DATA.has_key("notebook") :
			self.NOTEBOOK = self.STATE.DATA["notebook"]

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		__label = self.xml.get_widget("label87")
		__label.set_label( \
_("Quit VEE.\nAll the opened tab will be closed."))

	def on_ok (self, widget) :
		self.rememberGememetry()
		#self.removeAllTab()

		gtk.main_quit()

		return True

	def rememberGememetry (self) :
		# save the latest window geometry.
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(x, y) = self.WIDGET_ROOT.get_position()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (__wh0[0], __wh0[1], x, y) \
		)

	def removeAllTab (self) :
		ALL_REMOVED = True

		# try to close all the tab.
		_n = self.NOTEBOOK.get_n_pages() - 1
		for i in range(_n) :
			try :
				ch = self.LIST_TAB[i]
			except :
				break

			try :
				exit_method = getattr(ch.Child, "exit")
			except AttributeError :
				pass
			else :
				ch.Child.exit()

				if not ch.Child.IS_REMOVED :
					ALL_REMOVED = False
					break

		if ALL_REMOVED : print "all removed"
		#gtk.main_quit()

class FileSelectionDialog (WIDGET.WIDGET) :

	comboSetChild = "vim"
	CALLBACK_FUNCTIONS = dict()
	STATE = None
	#THEME = None

	NOTEBOOK = None

	CHILD_VIM = 0
	CHILD_GVIM = 1

	PAGE_FILE = 0
	PAGE_DIRECTORY = 1

	LIST_STORED_FILES = list()

	COLOR_WARNING = "#FC4444"

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_open"	: self.on_open, \
			"on_cancel" : self.on_close, \
		}

		WIDGET.WIDGET.__init__( \
			self, "filechooserdialog", None, handler)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)
		#self.THEME = self.STATE.DATA["theme"]

		self.NOTEBOOK = self.xml.get_widget("notebook")

		# get the directory path, which was opened latest.
		__path = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["last-directory-path-in-fileselectdialog"]["key"])
		if not __path.strip() : __path = os.getenv("HOME")

		self.ChooserFile = self.xml.get_widget("filechooserwidget2")
		self.ChooserDirectory = self.xml.get_widget("filechooserwidget3")

		self.ChooserFile.set_current_folder(__path)

		self.comboSetChild = self.xml.get_widget("combobox2")

		self.comboSetChild.insert_text(self.CHILD_VIM, _("Open In VIM"))
		self.comboSetChild.insert_text(self.CHILD_GVIM, \
			_("Open In GVIM"))
		self.comboSetChild.set_active(self.CHILD_VIM)

		__checkbox_openInThisPage = self.xml.get_widget("checkbutton16")
		__checkbox_openInThisPage.set_label( \
			_("Open this _file(s) in current tab."))

		self.BOX_LAST_FILES = self.xml.get_widget("vbox23")
		self.BOX_LAST_DIRECTORIES = self.xml.get_widget("vbox26")

		__label = self.xml.get_widget("label109")
		__label.set_label(_("Recent Opened Files are,"))
		__label = self.xml.get_widget("label110")
		__label.set_label(_("Recent Opened Directories are,"))
		__label = self.xml.get_widget("label94")
		__label.set_label(_("Select Files"))
		__label = self.xml.get_widget("label95")
		__label.set_label(_("Select Directory"))

		# saved command list.
		EXPANDER = self.xml.get_widget("expander2")
		EXPANDER.connect( \
			"notify::expanded", self.expander_callback_files)

		EXPANDER = self.xml.get_widget("expander3")
		EXPANDER.connect( \
			"notify::expanded", self.expander_callback_directories)

		self.__create_treeview_files()
		self.__create_treeview_directories()

	def expander_callback_files (self, expander, param_spec, user_data=None):
		if expander.get_expanded():
			self.BOX_LAST_FILES.show()
			self.WIDGET_SELF.set_property("resizable", True)
		else:
			self.BOX_LAST_FILES.hide()
			#self.WIDGET_SELF.set_property("resizable", False)

	def expander_callback_directories (self, expander, param_spec, user_data=None):
		if expander.get_expanded():
			self.BOX_LAST_DIRECTORIES.show()
			self.WIDGET_SELF.set_property("resizable", True)
		else:
			self.BOX_LAST_DIRECTORIES.hide()
			#self.WIDGET_SELF.set_property("resizable", False)

	def __create_treeview_files (self) :
		self.TREEVIEW_LAST_FILES = self.xml.get_widget("treeview4")
		self.TREEVIEW_LAST_FILES.set_headers_visible(False)

		# connect signal
		self.TREEVIEW_LAST_FILES.connect( \
			"row-activated", self.on_select_command_files)

		# add the cells to the columns - 2 in the first
		cell = gtk.CellRendererText()

		# create a CellRenderers to render the data
		tvcolumn = gtk.TreeViewColumn("", cell, markup=0)
		tvcolumn.set_expand(True)
		tvcolumn.set_sort_column_id(0)
		tvcolumn.pack_start(cell, True)

		self.LISTSTORE_FILES = gtk.ListStore(str)
		self.TREEVIEW_LAST_FILES.set_model(self.LISTSTORE_FILES)
		self.TREEVIEW_LAST_FILES.append_column(tvcolumn)
		self.TREEVIEW_LAST_FILES.set_reorderable(True)

		__data = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["recent-opened-files"]["key"])

		try :
			__data0 = base64.decodestring(__data)
			__data1 = marshal.loads(__data0)

			if type(__data1) is list :
				LIST_STORED_FILES = __data1
		except EOFError :
			pass

		for i in LIST_STORED_FILES :
			if not i.strip() : continue
			self.__append_column_recent_files(i)

	def __append_column_recent_files (self, filename) :
		if not os.path.exists(filename) :
			__d = "<span foreground=\"%s\">%s</span>" % \
				(self.COLOR_WARNING, filename)
		else :
			__d = filename

		#print self.THEME.get_icon_file(filename)
		self.LISTSTORE_FILES.append([__d,])

	def __create_treeview_directories (self) :
		self.TREEVIEW_LAST_DIRECTORIES = self.xml.get_widget("treeview5")
		self.TREEVIEW_LAST_DIRECTORIES.set_headers_visible(False)

		# connect signal
		self.TREEVIEW_LAST_DIRECTORIES.connect( \
			"row-activated", self.on_select_command_directories)

		# add the cells to the columns - 2 in the first
		cell = gtk.CellRendererText()

		# create a CellRenderers to render the data
		tvcolumn = gtk.TreeViewColumn("", cell, markup=0)
		tvcolumn.set_expand(True)
		tvcolumn.set_sort_column_id(0)
		tvcolumn.pack_start(cell, True)

		self.LISTSTORE_DIRECTORIES = gtk.ListStore(str)
		self.TREEVIEW_LAST_DIRECTORIES.set_model(self.LISTSTORE_DIRECTORIES)
		self.TREEVIEW_LAST_DIRECTORIES.append_column(tvcolumn)
		self.TREEVIEW_LAST_DIRECTORIES.set_reorderable(True)

		__data = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["recent-opened-directories"]["key"])

		try :
			__data0 = base64.decodestring(__data)
			__data1 = marshal.loads(__data0)

			if type(__data1) is list :
				list_stored = __data1
		except EOFError :
			pass

		for i in list_stored :
			if not i.strip() : continue
			self.__append_column_recent_directory(i)

	def __append_column_recent_directory (self, directory) :
		if not os.path.exists(directory) or \
				not os.path.isdir(directory) :
			__d = "<span foreground=\"%s\">%s</span>" % \
				(self.COLOR_WARNING, directory)
		else :
			__d = directory

		#print self.THEME.get_icon_file(filename)
		self.LISTSTORE_DIRECTORIES.append([__d,])

	def on_select_command_files (self, widget, path, viewcolumn) :
		__tree_selection = self.TREEVIEW_LAST_FILES.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__value = self.LISTSTORE_FILES.get_value(__tree_iter, 0)
		except TypeError :
			return

		self.__open_files([__value,])

	def on_select_command_directories (self, widget, path, viewcolumn) :
		__tree_selection = self.TREEVIEW_LAST_DIRECTORIES.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__value = self.LISTSTORE_DIRECTORIES.get_value(__tree_iter, 0)
		except TypeError :
			return

		self.__open_directory(__value)

	def on_open (self, widget) :
		__current = self.NOTEBOOK.get_current_page()

		if __current == self.PAGE_FILE :
			self.on_open_file()
		elif __current == self.PAGE_DIRECTORY :
			self.on_open_directory()
		else :
			print "What on earth!!!"
			pass

	def on_open_directory (self) :
		__directory = self.ChooserDirectory.get_filename()

		self.__open_directory(__directory)

	def __open_directory (self, directoryname) :

		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("terminal", directory=directoryname)
		self.on_close(True)

	def on_open_file (self) :

		file_selected = list()
		if self.ChooserFile.get_select_multiple() :
			file_selected = self.ChooserFile.get_filenames()
		else :
			file_selected.append(self.ChooserFile.get_filename())

		self.__open_files(file_selected)

	def __open_files (self, file_selected=list()) :

		__b = self.xml.get_widget("checkbutton16")
		openInThisPage = __b.get_active()

		# save the current directory to gconf.
		self.GCONF_CLIENT.set_value( \
			"string",\
			Conf.SCHEMA["last-directory-path-in-fileselectdialog"]["key"], \
			os.path.dirname(file_selected[0]) \
		)

		__func = self.CALLBACK_FUNCTIONS["addPage"]
		for i in file_selected :
			if os.path.isdir(i) : continue

			if not openInThisPage :
				__type_child = self.comboSetChild.get_active()
				if __type_child == self.CHILD_VIM :
					childname = "vim"
				elif __type_child == self.CHILD_GVIM :
					childname = "gvim"
				else :
					pass

				__func(childname, filename=i)
			else :
				__current_page = \
					self.STATE.DATA["notebook"].get_current_page()

				__child_type = \
					self.STATE.DATA["tab-list"][__current_page].Child.CHILD_TYPE

				if __child_type == child.TYPE_GVIM :
					childname = "gvim"
				elif __child_type == child.TYPE_VIM :
					childname = "vim"
				else :
					pass

				__func( \
					childname, filename=i, openInThisPage=openInThisPage)

		self.on_close(True)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Dialog.py"


