# -*- coding: utf-8 -*-
import os
import gtk

import Conf, func, i18n

_ = i18n.gettext()

class Label (gtk.HBox) :

	LABELNAME = "None"
	STATE = None
	Child = None

	EVENTBOX = None

	WITHOUT_CLOSEBUTTON = False

	def __init__ (self, **kwargs) :

		gtk.HBox.__init__(self, False, 2)

		if kwargs.has_key("state") :
			self.STATE = kwargs["state"]

		if kwargs.has_key("labelname") :
			self.LABELNAME = kwargs["labelname"]

		if kwargs.has_key("without_closebutton") :
			if kwargs["without_closebutton"] :
				self.WITHOUT_CLOSEBUTTON = True

		self.make()
		self.show()

	def make (self) : pass

	def registerChild (self, child) :
		self.Child = child

class TabWithClose (Label) :

	def __init__ (self, **kwargs) :

		if kwargs.has_key("filename") :
			self.LABELNAME = kwargs["filename"]

		Label.__init__(self, **kwargs)

	def make (self, labelname=None) :
		if not labelname : labelname = self.LABELNAME

		# make label.
		self.Label = gtk.Label(labelname)
		self.Label.set_selectable(False)
		self.Label.set_justify(gtk.JUSTIFY_CENTER)
		self.Label.set_property("selectable", False)
		self.Label.show()

		self.EVENTBOX = gtk.EventBox()
		self.EVENTBOX.add(self.Label)
		self.EVENTBOX.show()

		# make close button
		if not self.WITHOUT_CLOSEBUTTON :
			self.Button = gtk.ToolButton(gtk.STOCK_CLOSE)
			self.Button.show()
			self.Button.connect("clicked", self.on_tab_close)

		# connect event with method.
		self.EVENTBOX.connect("event", self.on_tab_label)

		# add close button and label in HBOX
		self.pack_start(self.EVENTBOX, False)

		if not self.WITHOUT_CLOSEBUTTON :
			self.pack_end(self.Button, False)

	def on_tab_label (self, parm1, parm2) :
		__type = parm2.type

		if __type is gtk.gdk.ENTER_NOTIFY :
			if self.LABELNAME == "None" : return

			self.STATE.DATA["statusbar"].set_label( \
				" %s" % self.LABELNAME)
		elif __type is gtk.gdk.LEAVE_NOTIFY :
			self.STATE.DATA["statusbar"].set_label("")
		else :
			pass

	def on_tab_close (self, widget) :
		self.Child.exit()
		self.STATE.DATA["statusbar"].clean()

	def get_label (self) :
		return self.LABELNAME

	def set_label (self, label_name) :
		if not label_name :
			__label_name = ""
		else :
			__label_name = func.get_labelname(label_name)

		self.LABELNAME = __label_name
		self.Label.set_label(__label_name)

		# add toolip in event box
		__tooltip = gtk.Tooltips()
		__tooltip.set_tip(self.EVENTBOX, label_name)
		__tooltip.enable()

class TabWithCloseForVim (TabWithClose) :
	LABELNAME = None
	LABELNAME_SHORT = None

	def __init__ (self, **kwargs) :

		if kwargs.has_key("filename") :
			self.LABELNAME = kwargs["filename"]

		if self.LABELNAME.strip() :
			self.LABELNAME_SHORT = os.path.basename(self.LABELNAME)

		gtk.HBox.__init__(self, False, 2)

		if kwargs.has_key("state") :
			self.STATE = kwargs["state"]

		self.make(self.LABELNAME_SHORT)
		self.show()

	def set_label (self, text) :
		self.LABELNAME = text
		self.LABELNAME_SHORT = os.path.basename(text)

	def get_label (self) :
		return self.LABELNAME

class Statusbar :

	CONTEXT = None
	CONTEXT_ID = None
	MESSAGE_ID = None

	INSTANCE_STATUSBAR = None

	TMP_TEXT = str()

	def __init__ (self, instanceOfStatusbar, context="default") :

		if not isinstance(instanceOfStatusbar, gtk.Statusbar) :
			raise ValueError, \
				_("instanceOfStatusbar must be gtk.Statusbar")
		else :
			self.INSTANCE_STATUSBAR = instanceOfStatusbar

		self.CONTEXT_ID = self.INSTANCE_STATUSBAR.get_context_id(context)

	def clean (self) :
		self.set_label("")

	def set_label (self, text) :

		# remove previous message.
		try :
			self.INSTANCE_STATUSBAR.remove(self.CONTEXT_ID, self.MESSAGE_ID)
		except :
			pass

		self.MESSAGE_ID = self.INSTANCE_STATUSBAR.push(self.CONTEXT_ID, text)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Label.py"


