# -*- coding: utf-8 -*-
import sys, os

import i18n

_ = i18n.gettext()

import gtk, vte
import Label, GConf, Conf, child

class TAB :

	NOTEBOOK = None
	STATE = None

	WIDGET_ROOT = None
	LIST_TAB = list()

	INSTANCE_LABEL = None
	INSTANCE_SCROLLEDWINDOW = None

	STR_TAB_NAME = "None"

	WITHOUT_CLOSEBUTTON = False

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			if not self.STATE.DATA.has_key("notebook") :
				raise ValueError, _("notebook was not instantiated.")
			else :
				self.NOTEBOOK = self.STATE.DATA["notebook"]

		if kwargs.has_key("without_closebutton") :
			self.WITHOUT_CLOSEBUTTON = kwargs["without_closebutton"]

		self.WIDGET_ROOT = self.NOTEBOOK.get_root_window()
		self.LIST_TAB = self.STATE.DATA["tab-list"]

	def on_signal_remove_tab (self, widget) :

		self.Child.exit()

		currnet_page = self.NOTEBOOK.get_current_page()
		self.NOTEBOOK.remove_page(currnet_page)
		del(self.LIST_TAB[currnet_page])

	def addLabel (self, label) :

		if not isinstance(label, gtk.Widget) :
			raise ValueError, \
				_("label must be the subclass of gtk.Widget.")

		self.INSTANCE_LABEL = label

	def __makeLabel (self) :

		if not self.INSTANCE_LABEL :
			self.INSTANCE_LABEL = Label.TabWithClose( \
				state=self.STATE, \
				labelname=self.STR_TAB_NAME, \
				without_closebutton=self.WITHOUT_CLOSEBUTTON)

			self.INSTANCE_LABEL.show()

	#########################################################
	# Child
	def connectSignalChild (self) :
		self.Child.WIDGET.connect(self.Child.SIGNAL_REMOVE, \
			self.on_signal_remove_tab)

	def addChild (self, child) :

		self.Child = child

		self.connectSignalChild()

		self.__makeLabel()

		# create scrolled window
		self.INSTANCE_SCROLLEDWINDOW = gtk.ScrolledWindow()
		self.INSTANCE_SCROLLEDWINDOW.set_policy( \
			gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)

		self.INSTANCE_SCROLLEDWINDOW.set_border_width(0)
		self.INSTANCE_SCROLLEDWINDOW.set_shadow_type(gtk.SHADOW_NONE)
		self.INSTANCE_SCROLLEDWINDOW.set_property("can-focus", True)
		self.INSTANCE_SCROLLEDWINDOW.set_property("has-focus", True)
		self.INSTANCE_SCROLLEDWINDOW.set_property("sensitive", True)

		self.INSTANCE_SCROLLEDWINDOW.grab_focus()

		self.INSTANCE_SCROLLEDWINDOW.add_with_viewport(self.Child.WIDGET)
		self.INSTANCE_SCROLLEDWINDOW.show()

		# add ScrolledWindow in notebook
		self.INSTANCE_LABEL.registerChild(self.Child)
		self.NOTEBOOK.append_page( \
			self.INSTANCE_SCROLLEDWINDOW, self.INSTANCE_LABEL)

		# focus in widget.
		self.NOTEBOOK.set_current_page(self.NOTEBOOK.get_n_pages() - 1)

	def addVTE (self, instancevte) :

		if not isinstance(instancevte.WIDGET, vte.Terminal) :
			raise ValueError, _("vte must be instance of VTE class.")

		self.Child = instancevte

		self.connectSignalChild()

		self.__makeLabel()

		# create scrolled window
		self.INSTANCE_SCROLLEDWINDOW = gtk.ScrolledWindow()
		self.INSTANCE_SCROLLEDWINDOW.set_policy( \
			gtk.POLICY_NEVER, gtk.POLICY_NEVER)

		self.INSTANCE_SCROLLEDWINDOW.set_border_width(0)
		self.INSTANCE_SCROLLEDWINDOW.set_shadow_type(gtk.SHADOW_NONE)
		self.INSTANCE_SCROLLEDWINDOW.set_property("can-focus", True)
		self.INSTANCE_SCROLLEDWINDOW.set_property("has-focus", True)

		self.INSTANCE_SCROLLEDWINDOW.add_with_viewport(self.Child.WIDGET)
		self.INSTANCE_SCROLLEDWINDOW.show()

		# add ScrolledWindow in notebook
		self.INSTANCE_LABEL.registerChild(self.Child)
		self.NOTEBOOK.append_page( \
			self.INSTANCE_SCROLLEDWINDOW, self.INSTANCE_LABEL)

		# focus in VTE.
		self.NOTEBOOK.set_current_page(self.NOTEBOOK.get_n_pages() - 1)
		self.Child.WIDGET.grab_focus()

	def addWidget (self, widget, labelname=None) :

		self.Child = widget

		if not isinstance(widget, gtk.Widget) :
			raise ValueError, \
				_("widget must be instance of gtk.Widget class.")

		self.INSTANCE_LABEL = Label.TabWithClose( \
			state=self.STATE, filename=labelname, \
			without_closebutton=self.WITHOUT_CLOSEBUTTON)
		self.INSTANCE_LABEL.show()

		self.NOTEBOOK.append_page( \
			widget, self.INSTANCE_LABEL)

		self.NOTEBOOK.set_current_page(self.NOTEBOOK.get_n_pages() - 1)

		self.Child.grab_focus()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "TAB.py"

