# -*- coding: utf-8 -*-
import os
import gtk, gobject

import TAB, WIDGET, Label, State, \
	Dialog, GConf, Conf, Menu, child, \
	func, Panel, GNOME

import i18n
_ = i18n.gettext()

class VEE (WIDGET.WIDGET) :

	LIST_TAB = list()
	NOTEBOOK = None

	STATE = None
	IS_LOGO = True

	Toolbar = None
	Menubar = None

	ARGS_OPTIONS = dict()
	ARGS_ARGS = list()

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE_EXTERNAL_COMMAND = None

	LIST_TAB_SHORTCUT = dict()

	def __init__ (self, **kwargs) :

		self.STATE = State.State()
		#self.THEME = GNOME.Theme()
		#self.STATE.set_value("theme", self.THEME)

		# parse arguments and options.
		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		handler = { \
			"on_new_vee" : self.on_new_vee, \
			\
			"on_insert_vim" : self.on_insert_vim, \
			"on_insert_gvim" : self.on_insert_gvim, \
			"on_insert_terminal" : self.on_insert_terminal, \
			"on_external_command" : self.on_external_command, \
			\
			"on_open_file_dialog" : self.on_fileSelectionDialog, \
			"on_external_command_dialog" : \
				self.on_external_command_dialog, \
			\
			"on_font_select" : self.on_fontSelectionDialog, \
			"on_font_increase" : self.on_font_increase, \
			"on_font_decrease" : self.on_font_decrease, \
			\
			"on_next_tab" : self.on_next_tab, \
			"on_previous_tab" : self.on_previous_tab, \
			\
			"on_remove_page" : self.on_remove_page, \
			\
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			\
			"on_preferences" : self.on_preferences, \
			"on_about" : self.on_about, \
			\
			"on_quit_all" : self.on_quit_all, \
		}

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		WIDGET.WIDGET.__init__(self, "vee", None, handler)
		self.__set_geometry()

		self.WIDGET_SELF.set_title(_("vee"))

		# create accelerator group.
		self.AccelGrpGlobal = gtk.AccelGroup()
		self.AccelGrpWhenHideMenubar = gtk.AccelGroup()

		# register global keyboard shortcut.
		self.WIDGET_SELF.add_accel_group(self.AccelGrpGlobal)
		self.WIDGET_SELF.add_accel_group(self.AccelGrpWhenHideMenubar)

		self.__activate_accelerator( \
			self.AccelGrpGlobal, Conf.KEYBOARD_SHORTCUT_GLOBAL)
		self.__activate_accelerator( \
			self.AccelGrpWhenHideMenubar, \
			Conf.KEYBOARD_SHORTCUT_WHEN_HIDE_MENUBAR)

		self.WIDGET_SELF.set_events(gtk.gdk.KEY_RELEASE)
		self.WIDGET_SELF.add_events(gtk.gdk.KEY_RELEASE)

		__state = { \
			"toolbar" : self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR,
			"menubar" : self.ARGS_OPTIONS.ARG_SHOW_MENUBAR,
			"bookmark" : self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK,
		}

		self.STATE.set_value("toggled-toolbar", not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR)
		self.STATE.set_value("toggled-menubar", not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR)
		self.STATE.set_value("toggled-bookmark", not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK)

		__callback_functions = {"addPage" : self.addPage}
		gconf_notify = GConf.Notify( \
			callback_functions=__callback_functions, \
			state=self.STATE \
		)

		gconf_notify.add()

		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)

		self.NOTEBOOK = self.xml.get_widget("notebook1")
		self.NOTEBOOK.remove_page(0)
		self.NOTEBOOK.popup_disable()
		self.NOTEBOOK.connect_after( \
			"switch-page", self.on_notebook_switch_page)

		# store information into state
		self.STATE.set_value("root-widget", self.WIDGET_SELF)
		self.STATE.set_value("notebook", self.NOTEBOOK)
		self.STATE.set_value("tab-list", self.LIST_TAB)

		# status bar.
		STATUSBAR = Label.Statusbar(self.xml.get_widget("statusbar1"))
		self.STATE.set_value("statusbar", STATUSBAR)

		# set event.
		EventBox_Notebook = self.xml.get_widget("eventbox1")
		EventBox_Notebook.connect("event", self.on_set_background_logo)
		EventBox_Notebook.connect( \
			"key-release-event", self.on_prevent_key_intercept)

		# toolbar and menubar
		self.Toolbar = self.xml.get_widget("toolbar1")

		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"]) :
			self.Toolbar.hide()

		self.Menubar = self.xml.get_widget("hbox1")
		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"]) :
			self.Menubar.hide()

		self.PANEL_BOOKMARK = self.xml.get_widget("vbox11")
		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-bookmark"]["key"]) :
			self.PANEL_BOOKMARK.hide()

		self.STATE.set_value("panel-bookmark", self.PANEL_BOOKMARK)
		self.STATE.set_value("toolbar", self.Toolbar)
		self.STATE.set_value("menubar", self.Menubar)

		# external command entry.
		ENTRY_EXTERNAL_COMMAND = \
			self.xml.get_widget("comboboxentry2").child
		ENTRY_EXTERNAL_COMMAND.connect("activate", self.on_external_command)
		__completion = gtk.EntryCompletion()
		ENTRY_EXTERNAL_COMMAND.set_completion(__completion)
		self.LISTSTORE_EXTERNAL_COMMAND = gtk.ListStore(gobject.TYPE_STRING)
		__completion.set_model(self.LISTSTORE_EXTERNAL_COMMAND)
		__completion.set_text_column(0)

		if len(self.ARGS_ARGS) > 0 :
			for i in self.ARGS_ARGS :
				self.addPage("vim", filename=i)
		else :
			if self.ARGS_OPTIONS.ARG_START_WITH_VIM :
				self.addPage("vim")
			if self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL :
				self.addPage("terminal")

		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR : self.Toolbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR : self.Menubar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK : self.PANEL_BOOKMARK.hide()

		# activate popup menu
		self.NOTEBOOK.connect( \
			"button-press-event", \
			Menu.on_show_popup_full, \
			self.WIDGET_SELF, \
			self.STATE, \
			__callback_functions, \
			self.LISTSTORE_EXTERNAL_COMMAND \
		)

		# set menu label name
		self.__set_label_menu()

		###############################################################
		# ACTIVATE dnd.
		self.NOTEBOOK.connect( \
			"drag_data_received", self.on_drag_received)

		self.Menubar.connect( \
			"drag_data_received", self.on_drag_received)

		self.Toolbar.connect( \
			"drag_data_received", self.on_drag_received)

		self.NOTEBOOK.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Menubar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Toolbar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		#########################################################
		# settting for toolbutton.
		__button_gvim = self.xml.get_widget("toolbutton12")

		# hide new window toolbutton.
		__button_new_window = self.xml.get_widget("toolbutton13")
		__button_new_window.hide()

		__button_vim = self.xml.get_widget("toolbutton1")
		__button_terminal = self.xml.get_widget("toolbutton8")
		__openfile_button = self.xml.get_widget("toolbutton5")
		__next_tab_button = self.xml.get_widget("toolbutton9")
		__perv_tab_button = self.xml.get_widget("toolbutton10")
		__command_label = self.xml.get_widget("toolbutton14")
		__command_label.set_label(_("Run Command"))

		# connect signal for toolbutton.
		__button_vim.connect( \
			"drag_data_received", self.on_drag_received_button_vim)
		__button_vim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_gvim.connect( \
			"drag_data_received", self.on_drag_received_button_gvim)
		__button_gvim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_terminal.connect( \
			"drag_data_received", self.on_drag_received_button_terminal)
		__button_terminal.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# whether gvim button set visible or not.
		__a = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-gvim"]["key"])

		self.STATE.set_value("gvim-button", __button_gvim)
		if len(__a) < 1 : __button_gvim.hide()

		# set label of toolbutton
		__button_gvim.set_label(_("GVIM"))
		__button_vim.set_label(_("VIM"))
		__openfile_button.set_label(_("Open File"))
		__button_terminal.set_label(_("Open Terminal"))
		__next_tab_button.set_label(_("Next Tab"))
		__perv_tab_button.set_label(_("Previous Tab"))

		# connect signal
		self.PANEL_BOOKMARK.connect("hide", self.on_notify_bookmark)
		self.PANEL_BOOKMARK.connect("show", self.on_notify_bookmark)
		# set the label of the bookmark toggle button.
		self.on_notify_bookmark()

		# creating Bookmarks
		self.Bookmarks = Panel.Bookmarks( \
			self.xml, \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	# EVENT HANDLER #####################################################
	def on_new_vee (self, widget) :
		main(args_options=self.ARGS_OPTIONS, args_args=self.ARGS_ARGS)

	def on_prevent_key_intercept (self, parm1, parm2) :
		__n = self.NOTEBOOK.get_current_page()
		try :
			self.LIST_TAB[__n].Child.WIDGET.grab_focus()
		except :
			pass

	def __addAccelKeySwitchTab (self) :
		"""
		그놈 터미널이나 에피파니처럼 Alt+숫자키로 탭이동하는 패치.
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		__c = Conf.LIST_KEYBOARD_SHORTCUT["modifier-switch-tab"]

		num = len(self.LIST_TAB_SHORTCUT)
		__key, __mod = gtk.accelerator_parse(__c[0] % (num + 1))

		if self.LIST_TAB_SHORTCUT.has_key(__key) :
			return
		else :
			self.LIST_TAB_SHORTCUT[__key] = num
			self.AccelGrpGlobal.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__c[1]))

	def on_notebook_switch_page (self, widget, parm1, parm2) :

		if len(self.LIST_TAB) < 1 : return

		# change window title.
		current_page = self.NOTEBOOK.get_current_page()
		try :
			__title = self.LIST_TAB[current_page].Child.get_title()
		except IndexError :
			return
		else :
			self.set_title(__title)

	def on_drag_received_button_vim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_drag_received_button_gvim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("gvim", filename=__path)

	def on_drag_received_button_terminal \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("terminal", directory=__path)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_quit_all \
			(self, parm1, parm2=None, parm3=None, parm4=None) :
		Dialog.AskCloseAllTabDialog(self.WIDGET_SELF, self.STATE)

		return True

	def on_external_command_dialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}
		ExternalCommand( \
			state=self.STATE, \
			callback_functions=__callback_functions, \
			completion_liststore=self.LISTSTORE_EXTERNAL_COMMAND \
		)

	def on_external_command (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE_EXTERNAL_COMMAND.append([__c, ])
		self.addPage("external_command", external_command=__c.strip())

		# make this be blank.
		widget.set_text("")

	def on_window_size_changed (self, widget, parm1) :
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(w, h) = self.WIDGET_SELF.get_size()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (w, h, __wh0[2], __wh0[3]) \
		)

	def on_toggle_menubar (self, widget) :
		if self.Menubar.get_property("visible") :
			self.Menubar.hide()
		else :
			self.Menubar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-menubar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_toggle_toolbar (self, widget) :
		if self.Toolbar.get_property("visible") :
			self.Toolbar.hide()
		else :
			self.Toolbar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-toolbar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_notify_bookmark (self, widget=None) :
		__label = self.xml.get_widget("label93")
		if self.PANEL_BOOKMARK.get_property("visible") :
			__label.set_label(_("Hide Bookmark Panel (Ctrl+Alt+B)"))
		else :
			__label.set_label(_("Show Bookmark Panel (Ctrl+Alt+B)"))

	def on_toggle_bookmark (self, widget) :
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def on_set_background_logo (self, parm1, parm2) :

		if self.NOTEBOOK.get_n_pages() < 1 :
			self.addLogo()

	def on_fileSelectionDialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}

		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def on_fontSelectionDialog (self, widget) :
		Dialog.FontSelectionDialog( \
			self.xml, self.LIST_TAB[self.NOTEBOOK.get_current_page()])

	def on_preferences (self, widget) :
		Preferences()

	def on_about (self, widget) :
		About()

	def on_insert_gvim (self, widget) :
		self.addPage("gvim")

	def on_insert_vim (self, widget) :
		self.addPage("vim")

	def on_insert_terminal (self, widget) :
		self.addPage("terminal")

	def on_remove_page (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()
		tab = self.LIST_TAB[current_page]
		tab.Child.exit()
		STATUSBAR.clean()

	def on_font_decrease (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def on_font_increase (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def on_next_tab (self, widget) :
		self.NOTEBOOK.next_page()

	def on_previous_tab (self, widget) :
		self.NOTEBOOK.prev_page()

	def on_change_title (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()

		__title = self.LIST_TAB[current_page].Child.get_title()

		self.set_title(__title)
		self.LIST_TAB[current_page].INSTANCE_LABEL.set_label(__title)

	#------------------------------------------------------------
	# Accel HANDLER
	def ac_show_tab_list (self, widget, parm1, parm2, parm3) :
		if len(self.LIST_TAB) < 1 : return
		TabList(state=self.STATE)

	def ac_toggle_bookmark (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child(child.TYPE_TERMINAL)

	def ac_change_nth_tab (self, parm1, parm2, parm3, parm4) :
		"""
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		self.NOTEBOOK.grab_focus()
		__n = self.LIST_TAB_SHORTCUT[parm3]
		if __n == self.NOTEBOOK.get_current_page() : return

		self.NOTEBOOK.set_current_page(__n)

	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def ac_insert_gvim (self, parm1, parm2, parm3, parm4) :
		self.addPage("gvim")

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_fileSelectionDialog  (self, parm1, parm2, parm3, parm4) :
		__callback_functions = {"addPage" : self.addPage}
		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_rotate_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		__entry = self.xml.get_widget("comboboxentry2").child
		__entry.grab_focus()

	#############################################################
	# etc method.
	def __set_geometry (self) :
		# window size matters.
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])

		__wh0 = [ int(i) for i in __wh.split(",")]

		# resize() and set_size_request will change the window size, but
		# set_size_request keep the window from being smaller.
		self.WIDGET_SELF.resize(__wh0[0], __wh0[1])
		#self.WIDGET_SELF.move(__wh0[2], __wh0[3])
		#self.WIDGET_SELF.set_size_request(__wh0[0], __wh0[1])
		#self.WIDGET_SELF.set_gravity(gtk.gdk.GRAVITY_STATIC)

		if self.ARGS_OPTIONS.ARG_MAXIMIZE_WINDOW :
			self.WIDGET_SELF.maximize()

		self.WIDGET_SELF.connect( \
			"size_request", self.on_window_size_changed)

	def __set_label_menu (self) :

		menu_items = ( \
			("file1", "File",),
			("Open", "_Open (Alt+Shift+F)",),
			("NewVIM", "_New VIM (Ctrl+Alt+V)",),
			("new_gvim1", "New _GVIM (Ctrl+Alt+G)",),
			("NewTerminal", "_New Terminal (Ctrl+Alt+Z)",),
			("new_vee_(ctrl+shift+m)1", "New VEE (Ctrl+Shift+M)",),
			("close1", "_Close",),
			("quit", "_Quit (Ctrl+Q)",),
			("edit1", "Edit",),
			("edit_profiles1", "Edit profiles",),
			("view2", "_View",),
			("show_menubar1", "Toggle show/hide menubar",),
			("show_toolbar1", "Toggle show/hide toolbar",),
			("previous_tab1", "Previous tab (Ctrl+Shift+PgDn)",),
			("next_tab1", "Next Tab (Ctrl+Shift+PgUp)",),
			("increase_fonts2", "_Increase fonts (Ctrl+=)",),
			("decrease_fonts2", "_Decrease fonts (Ctrl+-)",),
			("preferences1", "Preferences",),
			("help1", "Help",),
			("about1", "About",),
		)

		for i, j in menu_items :
			__m = self.xml.get_widget(i)
			__m.get_children()[0].set_label(_(j))

	def set_title (self, strings) :
		self.WIDGET_SELF.set_title(_("%s : VEE") % strings)

	def reset_child (self, type) :
		if len(self.LIST_TAB) < 1 : return

		for i in self.LIST_TAB :
			if i.Child.CHILD_TYPE == type :
				i.Child.reset()

	def __activate_accelerator \
			(self, accel_group, shortcut_tuple=tuple()) :
		if len(shortcut_tuple) < 1 : return False

		for i in shortcut_tuple :
			__o = Conf.LIST_KEYBOARD_SHORTCUT[i]

			if len(__o) < 2 : continue

			__key, __mod = gtk.accelerator_parse(__o[0])
			accel_group.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__o[1]))

		return True

	def addLogo (self) :

		Logo = gtk.Image()
		Logo.set_from_file(os.path.join(Conf.DIR_PIXMAPS, "vee.png"))
		Logo.show()

		__eventbox = gtk.EventBox()
		__eventbox.add(Logo)
		__eventbox.show()

		tab = TAB.TAB( \
			state=self.STATE, \
			without_closebutton=True)

		tab.addWidget(__eventbox, _("VEE"))
		self.WIDGET_SELF.set_title(_("vee"))

		self.IS_LOGO = True

	def addPage (self, childname, **kwargs) :
		if self.IS_LOGO :
			self.NOTEBOOK.remove_page(0)
			self.IS_LOGO = False

		__tab = child.getTab(childname)
		tab = __tab(self.STATE, **kwargs)

		tab.make()

		self.__addAccelKeySwitchTab()

	def addExample (self) :

		if self.IS_LOGO :
			self.NOTEBOOK.remove_page(0)
			self.IS_LOGO = False

		__example = child.getChild("example")
		example = __example()
		example.make()

		tab = TAB.TAB(state=self.STATE)
		tab.STR_TAB_NAME = _("Example")
		tab.addVTE(example)

		self.LIST_TAB.append(tab)

		example.WIDGET.connect( \
			"window-title-changed", self.on_change_title)

class NoValidCommand (WIDGET.WIDGET) :

	def __init__ (self, command=str()) :
		WIDGET.WIDGET.__init__(self, "error")

		self.WIDGET_SELF.set_title(_("This command does not exist. Check it out."))

		if command.strip() :
			__label = self.xml.get_widget("label90")
			__label.set_label( \
				_("\n'%s' does not exist. Check it.\n\n") % command \
			)

class TabList (WIDGET.WIDGET) :

	STATE = None
	LIST_TAB = list()
	NOTEBOOK = None

	CURRENT_PAGE = int()

	BOX = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")

		self.STATE = kwargs["state"]
		self.LIST_TAB = self.STATE.get_value("tab-list")
		self.NOTEBOOK = self.STATE.get_value("notebook")

		# get current page.
		self.CURRENT_PAGE = self.NOTEBOOK.get_current_page()

		WIDGET.WIDGET.__init__(self, "tablist", None)

		self.__create_list()

		# set label.
		self.WIDGET_SELF.set_title(_("List Tabs."))
		__label = self.xml.get_widget("label101")
		__label.set_label(_("<b>Tab List - Select One.</b>"))

	def __create_list (self) :
		self.BOX = self.xml.get_widget("vbox19")
		__n = 0
		for i in self.LIST_TAB :
			# get the name of each tab.
			__t = i.Child.CHILD_TYPE
			if __t == child.TYPE_TERMINAL :
				__type = "terminal"
				__label = i.Child.DIRECTORY
			elif __t == child.TYPE_EXTERNAL_COMMAND :
				__type = "external_command"
				__label = i.Child.EXTERNAL_COMMAND
			elif __t == child.TYPE_VIM :
				__type = "vim"
				__label = i.Child.FILENAME
			elif __t == child.TYPE_GVIM :
				__type = "gvim"
				__label = i.Child.FILENAME
			else :
				return

			self.append_item(__type, __label, __n + 1)
			__n += 1

		__1st = self.BOX.get_children()[self.CURRENT_PAGE]
		__1st.set_active(True)
		__1st.grab_focus()

	def append_item (self, type, label, seq) :
		__label = gtk.Label(" %d : %s" % (seq, label))
		__image = self.get_icon(type)
		__label.show()
		__image.show()

		__box = gtk.HBox()
		__box.pack_start(__image, expand=False, fill=False)
		__box.pack_start(__label, expand=False, fill=False)
		__box.set_property("homogeneous", False)
		__box.show()

		__button = gtk.ToggleButton()
		__button.add(__box)
		__button.set_data("seq", seq)
		__button.show()

		__button.connect("focus_out_event", self.on_unselect_item)
		__button.connect("focus_in_event", self.on_select_item)
		__button.connect("event", self.on_select_event)

		self.BOX.pack_start(__button)

	def on_unselect_item (self, widget, event) :
		widget.set_active(False)

	def on_select_item (self, widget, event) :
		widget.set_active(True)

	def on_select_event (self, widget, event) :
		try :
			event.keyval
		except AttributeError :
			return

		if event.keyval == 65293 :
			num_page = widget.get_data("seq") - 1
			self.NOTEBOOK.set_current_page(num_page)

	def get_icon (self, type) :

		if type == "category" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "category.png")
		elif type == "terminal" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "terminal.png")
		elif type == "external_command" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "external-command.png")
		elif type == "vim" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "vim.png")
		elif type == "gvim" :
			__path = os.path.join(Conf.DIR_PIXMAPS, "gvim.png")

		# create category icon image
		__p = gtk.gdk.pixbuf_new_from_file_at_size(__path, 50, 50)
		__i = gtk.Image()
		__i.set_from_pixbuf(__p)

		return __i

class ExternalCommand (WIDGET.WIDGET) :

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE = None
	STATE = None
	CALLBACK_FUNCTIONS = dict()
	TREEVIEW_LAST_COMMAND = None

	GCONF_CLIENT = None

	LIST_STORED = list()

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("completion_liststore") :
			raise ValueError, _("completion_liststore must be included.")
		else :
			self.LISTSTORE = kwargs["completion_liststore"]

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		handler = { \
			"on_ok"	: self.on_ok, \
			"on_add_command"	: self.on_add_command, \
			"on_remove_command"	: self.on_remove_command, \
		}

		WIDGET.WIDGET.__init__( \
			self, "external_command", None, handler)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		self.BOX_LAST_COMMAND = self.xml.get_widget("vbox17")
		# by default, hide it.
		#self.BOX_LAST_COMMAND.hide()

		__label = self.xml.get_widget("label92")
		__label.set_label(_("Run Command"))

		self.ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("comboboxentry1")
		__completion = gtk.EntryCompletion()
		self.ENTRY_EXTERNAL_COMMAND.child.set_completion(__completion)
		self.ENTRY_EXTERNAL_COMMAND.child.grab_focus()
		self.ENTRY_EXTERNAL_COMMAND.child.connect("activate", self.on_ok)
		self.ENTRY_EXTERNAL_COMMAND.child.connect( \
			"changed", self.on_changed_entry)

		__completion.set_model(self.LISTSTORE)
		__completion.set_text_column(0)

		# saved command list.
		self.EXPANDER = self.xml.get_widget("expander1")
		self.EXPANDER.connect("notify::expanded", self.expander_callback)
		self.WIDGET_SELF.set_title(_("Run Command"))

		# buttons
		self.BUTTON_ADD = self.xml.get_widget("button_add")
		self.BUTTON_ADD.set_property("sensitive", False)
		self.BUTTON_REMOVE = self.xml.get_widget("button_remove")
		self.BUTTON_REMOVE.set_property("sensitive", False)

		__label = self.xml.get_widget("label97")
		__label0 = self.xml.get_widget("label98")
		__label.set_label(_("Add"))
		__label0.set_label(_("Remove"))

		__label = self.xml.get_widget("label96")
		__label.set_label(_("Saved commands."))

		self.__load_list()
		self.__create_treeview()

	def __load_list (self) :

		# get the stored list of external command list.
		__data = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["external-command-list"]["key"])

		__data0 = base64.decodestring(__data)
		__data1 = marshal.loads(__data0)

		if type(__data1) is list :
			self.LIST_STORED = __data1

	def __store_list (self) :
		__data = marshal.dumps(self.LIST_STORED)
		__data0 = base64.encodestring(__data)

		self.GCONF_CLIENT.set_value("string", \
			Conf.SCHEMA["external-command-list"]["key"], \
			__data0 \
		)

	def __store_item (self, command) :
		self.LIST_STORED.append(command)
		self.__store_list()

	def on_changed_entry (self, widget) :
		__d = widget.get_text().strip()

		if len(__d) < 1 :
			self.BUTTON_ADD.set_property("sensitive", False)
		else :
			self.BUTTON_ADD.set_property("sensitive", True)

	def __create_treeview (self) :
		self.TREEVIEW_LAST_COMMAND = self.xml.get_widget("treeview3")
		self.TREEVIEW_LAST_COMMAND.set_headers_visible(False)

		# connect signal
		self.TREEVIEW_LAST_COMMAND.connect( \
			"cursor-changed", self.on_select_command)

		# create a CellRenderers to render the data
		tvcolumn = gtk.TreeViewColumn("")
		tvcolumn.set_expand(True)
		tvcolumn.set_sort_column_id(0)

		self.LISTSTORE = gtk.ListStore(str)
		self.TREEVIEW_LAST_COMMAND.set_model(self.LISTSTORE)
		self.TREEVIEW_LAST_COMMAND.append_column(tvcolumn)

		# add the cells to the columns - 2 in the first
		cell = gtk.CellRendererText()
		tvcolumn.pack_start(cell, True)
		tvcolumn.set_attributes(cell, text=0)

		self.TREEVIEW_LAST_COMMAND.set_reorderable(True)

		for i in self.LIST_STORED :
			print i
			self.__append_command(i)

	def __append_command (self, command) :
		if not command.strip() : return

		self.LISTSTORE.append(("%s" % command,))
		return

	def on_select_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__value = self.LISTSTORE.get_value(__tree_iter, 0)
		except TypeError :
			return

		self.ENTRY_EXTERNAL_COMMAND.child.set_text(__value)
		self.BUTTON_REMOVE.set_property("sensitive", True)

	def on_add_command (self, widget) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		self.__append_command(__c)
		# after add in tree, make entry to be blank.
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		self.__store_item(__c)

	def on_remove_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__path = self.LISTSTORE.get_path(__tree_iter)
		except TypeError :
			return

		self.LISTSTORE.remove(__tree_iter)
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		del(self.LIST_STORED[__path[0]])
		self.__store_list()

	def expander_callback(self, expander, param_spec, user_data=None):
		if expander.get_expanded():
			self.BOX_LAST_COMMAND.show()
			self.WIDGET_SELF.set_property("resizable", True)
		else:
			self.BOX_LAST_COMMAND.hide()
			self.WIDGET_SELF.set_property("resizable", False)

	def on_ok (self, widget) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE.append([__c, ])
		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("external_command", external_command=__c.strip())

		self.on_close(widget)

class About (WIDGET.WIDGET) :

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

	def on_ok (self, widget) :
		self.on_close(widget)

class Preferences (WIDGET.WIDGET) :

	GCONF_CLIENT = None

	FONT_DEFAULT_SYSTEM = str()

	def __init__ (self) :

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		handler = { \
			"on_use_system_font" : self.on_use_system_font, \
			"on_font_set_vim" : self.on_font_set_vim, \
			"on_font_set_terminal" : self.on_font_set_terminal, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_bookmark" : self.on_toggle_bookmark, \
			"on_change_vim" : self.on_change_vim, \
			"on_change_gvim" : self.on_change_gvim, \
			"on_change_terminal" : self.on_change_terminal, \
			"on_change_max_scrollline" : self.on_change_max_scrollline, \
		}

		WIDGET.WIDGET.__init__(self, "preferences", None, handler)

		############################################################
		# get widget
		__widget_font_vim = self.xml.get_widget("fontbutton3")
		__widget_font_terminal = self.xml.get_widget("fontbutton4")
		__widget_font_system_default = self.xml.get_widget("checkbutton12")
		__checkbutton_hide_menubar = self.xml.get_widget("checkbutton13")
		__checkbutton_hide_toolbar = self.xml.get_widget("checkbutton14")
		__checkbutton_hide_bookmark = self.xml.get_widget("checkbutton15")
		__widget_command_vim = self.xml.get_widget("entry13")
		__widget_command_gvim = self.xml.get_widget("entry16")
		__widget_command_terminal = self.xml.get_widget("entry14")
		__widget_max_scrollline = self.xml.get_widget("spinbutton1")
		__label_font_VIM = self.xml.get_widget("label75")
		__label_font_Terminal = self.xml.get_widget("label76")

		__label_tab0 = self.xml.get_widget("label51")
		__label_tab1 = self.xml.get_widget("label59")
		__label_tab2 = self.xml.get_widget("label88")

		__label_tab3 = self.xml.get_widget("label77")
		__label_tab4 = self.xml.get_widget("label78")
		__label_tab5 = self.xml.get_widget("label91")

		__label_tab6 = self.xml.get_widget("label50")
		__label_tab7 = self.xml.get_widget("label58")
		__label_tab8 = self.xml.get_widget("label89")

		__label = self.xml.get_widget("label102")
		__label.set_label(_("<b>Fonts</b>"))
		#__label = self.xml.get_widget("label103")
		#__label.set_label(_("<b>Colors</b>"))
		__label = self.xml.get_widget("label104")
		__label.set_label(_("Foreground : "))
		__label = self.xml.get_widget("label105")
		__label.set_label(_("Background : "))
		__label = self.xml.get_widget("label106")
		__label.set_label(_("Dim : "))
		__label = self.xml.get_widget("label107")
		__label.set_label(_("Highlight : "))
		__label = self.xml.get_widget("label108")
		__label.set_label(_("Cursor : "))
		__label = self.xml.get_widget("label111")
		__label.set_label(_("Fonts"))
		__label = self.xml.get_widget("label113")
		__label.set_label(_("Colors"))

		# set label
		__checkbutton_hide_menubar.set_label(_("Show menubar"))
		__checkbutton_hide_toolbar.set_label(_("Show toolbar"))
		__checkbutton_hide_bookmark.set_label(_("Show bookmark"))
		__widget_font_system_default.set_label( \
			_("Use gnome default terminal font."))
		__label_font_VIM.set_label(_("VIM Font : "))
		__label_font_Terminal.set_label(_("Terminal Font : "))
		__label_tab0.set_label(_("Main"))
		__label_tab1.set_label(_("Command"))
		__label_tab2.set_label(_("Terminal"))
		__label_tab3.set_label(_("VIM Command : "))
		__label_tab4.set_label(_("Terminal Command : "))
		__label_tab5.set_label(_("GVIM Command : "))
		#__label_tab6.set_label(_("<b>Main</b>"))
		#__label_tab7.set_label(_("<b>Command</b>"))
		__label_tab8.set_label(_("Maximum line number to scroll : "))

		# set default system font.
		self.FONT_DEFAULT_SYSTEM = self.GCONF_CLIENT.get_value( \
				Conf.GLOBAL_FONT_SYSTEM_DEFAULT)

		# set font name
		__fontname_vim = self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-vim"]["key"])
		__fontname_terminal = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-terminal"]["key"])

		if __fontname_vim :
			__widget_font_vim.set_font_name(__fontname_vim)

		if __fontname_terminal :
			__widget_font_terminal.set_font_name(__fontname_terminal)

		__use_system_default_font = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["use-system-default-font"]["key"])

		if __use_system_default_font :
			__widget_font_vim.set_sensitive(False)
			__widget_font_terminal.set_sensitive(False)
			__widget_font_system_default.set_active(True)
		else :
			__widget_font_system_default.set_active(False)

		# show/hide menubar, toolbar, bookmark
		__show_menubar = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"])
		__checkbutton_hide_menubar.set_active(__show_menubar)

		__show_toolbar = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"])
		__checkbutton_hide_toolbar.set_active(__show_toolbar)

		__show_bookmark = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-bookmark"]["key"])
		__checkbutton_hide_bookmark.set_active(__show_bookmark)

		__command_vim = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-vim"]["key"])
		__command_gvim = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-gvim"]["key"])
		__command_terminal = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-terminal"]["key"])

		__widget_command_vim.set_text(__command_vim)
		__widget_command_gvim.set_text(__command_gvim)
		__widget_command_terminal.set_text(__command_terminal)

		# max scrollable line
		__value_max_scrollline = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["max-scrollline"]["key"])

		__widget_max_scrollline.set_value(int(__value_max_scrollline))

		# set color
		__colorbutton_foreground = self.xml.get_widget("colorbutton1")
		__colorbutton_foreground.connect( \
			"color-set", self.on_color_changed, "foreground")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-foreground"]["key"])
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_foreground.set_color(__gdkColor)

		__colorbutton_background = self.xml.get_widget("colorbutton2")
		__colorbutton_background.connect( \
			"color-set", self.on_color_changed, "background")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-background"]["key"])
		__gdkColor = func.str_to_color(__c, "black")
		__colorbutton_background.set_color(__gdkColor)

		__colorbutton_dim = self.xml.get_widget("colorbutton3")
		__colorbutton_dim.connect( \
			"color-set", self.on_color_changed, "dim")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-dim"]["key"])
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_dim.set_color(__gdkColor)

		__colorbutton_highlight = self.xml.get_widget("colorbutton4")
		__colorbutton_highlight.connect( \
			"color-set", self.on_color_changed, "highlight")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-highlight"]["key"])
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_highlight.set_color(__gdkColor)

		__colorbutton_cursor = self.xml.get_widget("colorbutton5")
		__colorbutton_cursor.connect( \
			"color-set", self.on_color_changed, "cursor")
		__c = self.GCONF_CLIENT.get_value(Conf.SCHEMA["color-cursor"]["key"])
		__gdkColor = func.str_to_color(__c, "red")
		__colorbutton_cursor.set_color(__gdkColor)

	def on_color_changed (self, widget, type) :
		__c = func.color_to_str(widget.get_color())
		self.GCONF_CLIENT.set_value( \
			"string", \
			Conf.SCHEMA["color-%s" % (type)]["key"], \
			__c
		)

	def on_change_terminal (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-terminal"]["key"], \
			widget.get_text())

	def on_change_vim (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-vim"]["key"], \
			widget.get_text())

	def on_change_gvim (self, widget) :
		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["command-gvim"]["key"], \
			widget.get_text())

	def on_toggle_menubar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-menubar"]["key"], __is_activated)

	def on_toggle_toolbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-toolbar"]["key"], __is_activated)

	def on_toggle_bookmark (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value( \
			"bool", Conf.SCHEMA["show-bookmark"]["key"], __is_activated)

	def on_font_set_vim (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["font-vim"]["key"], __font_name)

	def on_font_set_terminal (self, widget) :
		__font_name = widget.get_font_name()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["font-terminal"]["key"], __font_name)

	def on_use_system_font (self, widget) :

		__checkbutton = self.xml.get_widget("checkbutton12")

		__buttonFontVIM = self.xml.get_widget("fontbutton3")
		__buttonFontTerminal = self.xml.get_widget("fontbutton4")

		__labelFontVIM = self.xml.get_widget("label75")
		__labelFontTerminal = self.xml.get_widget("label76")

		if __checkbutton.get_active() :

			__buttonFontTerminal.set_sensitive(False)
			__buttonFontVIM.set_sensitive(False)

			__labelFontTerminal.set_sensitive(False)
			__labelFontVIM.set_sensitive(False)

			self.GCONF_CLIENT.set_value( \
				"bool", Conf.SCHEMA["use-system-default-font"]["key"], True)
		else :
			self.GCONF_CLIENT.set_value( \
				"bool", Conf.SCHEMA["use-system-default-font"]["key"], False)

			__buttonFontTerminal.set_sensitive(True)
			__buttonFontVIM.set_sensitive(True)

			__labelFontTerminal.set_sensitive(True)
			__labelFontVIM.set_sensitive(True)

	def on_change_max_scrollline (self, widget) :
		__value = widget.get_value()

		self.GCONF_CLIENT.set_value( \
			"int", Conf.SCHEMA["max-scrollline"]["key"], int(__value))


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Window.py"

