# -*- coding: utf-8 -*-
import os, gtk, vte, pango
import child, __BASIC__, GConf, Conf, func, i18n

_ = i18n.gettext()

class egg (__BASIC__.egg) :

	WIDGET = None

	CHILD_TYPE = child.TYPE_VIM

	ARGUMENT = tuple()
	DIRECTORY = str()
	FORK_COMMAND = str()
	ENVIRONMENT = tuple()

	DEFAULT_FONTNAME = "Bitstream Vera Sans Mono 16"
	EMULATION = "xterm"
	#EMULATION = "linux"
	UNIT_FONT_DELM = 1000
	RANGE_FONT_SIZE = (10000, 30000)

	SIGNAL_REMOVE = "child-exited"

	MAX_SCROLL_LINE = 100

	EXTERNAL_COMMAND = str()

	ID_NOTIFY = None

	def __init__ (self, **kwargs) :

		if kwargs.has_key("environment") :
			if type(kwargs["environment"]) is not tuple :
				raise TypeError, _("The type of environment must be tuple.")

			self.ENVIRONMENT = kwargs["environment"]

		if kwargs.has_key("argument") :
			if type(kwargs["argument"]) is not tuple :
				raise TypeError, _("The type of argument must be tuple.")

			self.ARGUMENT = kwargs["argument"]

		if not kwargs.has_key("command") and not self.FORK_COMMAND :
			raise ValueError, _("command argument must be needed.")
		elif kwargs.has_key("command") :
			self.FORK_COMMAND = kwargs["command"]

		if kwargs.has_key("directory") :
			if os.path.isdir(kwargs["directory"]) :
				__dirname = kwargs["directory"]
			else :
				__dirname = os.path.dirname(kwargs["directory"])

			self.DIRECTORY = __dirname

		if kwargs.has_key("external_command") :
			self.EXTERNAL_COMMAND = kwargs["external_command"]

		self.GCONF_CLIENT = GConf.Client()

		self.MAX_SCROLL_LINE = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["max-scrollline"]["key"])

	def reset (self, parm1=None, parm2=None, parm3=None) :
		self.WIDGET.reset(True, False)
		self.WIDGET.feed_child("\n")

	def set_font_from_string (self, fontname) :
		self.WIDGET.set_font_from_string(fontname)
		self.reset()

	def set_font (self, fontDescription) :
		self.WIDGET.set_font(fontDescription)
		self.reset()

	def decrease_font (self, size=int()) :

		pd = self.WIDGET.get_font()

		__s = pd.get_size() - self.UNIT_FONT_DELM
		if __s not in \
				range(self.RANGE_FONT_SIZE[0], self.RANGE_FONT_SIZE[1]) :
			return

		pd.set_size(__s)
		self.WIDGET.set_font(pd)
		self.reset()

		return

	def increase_font (self, size=int()) :

		pd = self.WIDGET.get_font()

		__s = pd.get_size() + self.UNIT_FONT_DELM
		if __s not in \
				range(self.RANGE_FONT_SIZE[0], self.RANGE_FONT_SIZE[1]) :
			return

		pd.set_size(__s)
		self.WIDGET.set_font(pd)
		self.reset()

		return

	def make (self) :
		self.WIDGET = vte.Terminal()

		# DEFAULT SETTING.
		self.WIDGET.set_audible_bell(False)
		self.WIDGET.set_visible_bell(True)
		self.WIDGET.set_scroll_on_output(False)
		self.WIDGET.set_scrollback_lines(self.MAX_SCROLL_LINE)
		self.WIDGET.set_mouse_autohide(True)
		#self.WIDGET.set_size(100,300)
		self.set_color()
		self.set_notify()

		self.WIDGET.connect("char-size-changed", self.reset)
		self.reset()
		__pd = pango.FontDescription(self.DEFAULT_FONTNAME)
		self.WIDGET.set_font(__pd)

		self.fork_command()

		self.WIDGET.show()
		self.WIDGET.grab_remove()
		self.activate_dnd()

	def on_change_color (self, client, parm1, entry, type) :

		__c = self.GCONF_CLIENT.get_value_from_value(entry.get_value())
		__c0 = func.str_to_color(__c)

		try :
			__func = getattr(self.WIDGET, "set_color_%s" % type)
		except AttributeError :
			raise AttributeError, "What type, % is it?" % type
		else :
			__func(__c0)

	def on_set_font (self, client, parm1, entry, parm3) :
		__font = self.GCONF_CLIENT.get_value_from_value(entry.get_value())
		self.set_font_from_string(__font)

	def set_notify (self) :

		# color setting.
		self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["color-foreground"]["key"], \
			self.on_change_color, \
			"foreground" \
		)

		self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["color-background"]["key"], \
			self.on_change_color, \
			"background" \
		)

		self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["color-dim"]["key"], \
			self.on_change_color, \
			"dim" \
		)

		self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["color-highlight"]["key"], \
			self.on_change_color, \
			"highlight" \
		)

		self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["color-cursor"]["key"], \
			self.on_change_color, \
			"cursor" \
		)

	def set_color (self) :

		# initiate terminal color set.
		self.WIDGET.set_default_colors()

		__c = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["color-foreground"]["key"])
		__c0 = func.str_to_color(__c)
		self.WIDGET.set_color_foreground(__c0)

		__c = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["color-background"]["key"])
		__c0 = func.str_to_color(__c)
		self.WIDGET.set_color_background(__c0)

		__c = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["color-dim"]["key"])
		__c0 = func.str_to_color(__c)
		self.WIDGET.set_color_dim(__c0)

		__c = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["color-highlight"]["key"])
		__c0 = func.str_to_color(__c)
		self.WIDGET.set_color_highlight(__c0)

		__c = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["color-cursor"]["key"])
		__c0 = func.str_to_color(__c)
		self.WIDGET.set_color_cursor(__c0)

	def fork_command (self) :
		__argument = (self.FORK_COMMAND, ) + self.ARGUMENT
		__environment = ("TERM=%s" % self.EMULATION, ) + self.ENVIRONMENT

		self.WIDGET.fork_command( \
			self.FORK_COMMAND, \
			argv=__argument, \
			envv=__environment, \
			directory=self.DIRECTORY, \
		)

	def send (self, command) :
		self.WIDGET.feed_child(command)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.send(__path)

		return

		if targetType == Conf.DND_TARGET_COLOR :
			pass
		elif targetType == Conf.DND_TARGET_BGIMAGE :
			pass
		elif targetType == Conf.DND_TARGET_RESET_BG :
			pass
		elif targetType == Conf.DND_TARGET_URI_LIST :
			pass
		elif targetType == Conf.DND_TARGET_MOZ_URL :
			pass
		elif targetType == Conf.DND_TARGET_UTF8_STRING :
			pass
		elif targetType == Conf.DND_TARGET_COMPOUND_TEXT :
			pass
		elif targetType == Conf.DND_TARGET_TEXT_PLAIN :
			pass
		elif targetType == Conf.DND_TARGET_STRING :
			pass
		elif targetType == Conf.DND_TARGET_TEXT_PLAIN :
			pass
		elif targetType == Conf.DND_TARGET_TEXT :
			pass
		else :
			pass

	def exit (self) :
		if self.ID_NOTIFY :
			self.GCONF_CLIENT.CLIENT.notify_remove(self.ID_NOTIFY)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__VTE__.py"


