# -*- coding: utf-8 -*-
import os, base64, marshal
import child, __BASIC__, __VTE__, TAB, Conf, i18n

_ = i18n.gettext()

class egg (__VTE__.egg) :

	CHILD_TYPE = child.TYPE_TERMINAL
	FORK_COMMAND = "/bin/bash"
	ARGUMENT = ("-l", )

	def make (self) :
		if self.GCONF_CLIENT.get_value( \
				Conf.SCHEMA["use-system-default-font"]["key"]) :
			self.DEFAULT_FONTNAME = \
				self.GCONF_CLIENT.get_value(Conf.GLOBAL_FONT_SYSTEM_DEFAULT)
		else :
			self.DEFAULT_FONTNAME = \
				self.GCONF_CLIENT.get_value(Conf.SCHEMA["font-terminal"]["key"])

		self.FORK_COMMAND = \
			self.GCONF_CLIENT.get_value(Conf.SCHEMA["command-terminal"]["key"])

		__VTE__.egg.make(self)

		self.store_recent()

	def set_notify (self) :
		__VTE__.egg.set_notify(self)

		self.ID_NOTIFY = self.GCONF_CLIENT.CLIENT.notify_add( \
			Conf.SCHEMA["font-terminal"]["key"], \
			self.on_set_font \
		)

	def get_title (self) :
		__t = __VTE__.egg.get_title(self)

		if not __t : return str()

		__t0 = "".join(__t.split(":")[1:]).strip()

		if len(__t0) < 1 :
			__title = __t
		else :
			__title = __t0

		# save directory to self.DIRECTORY
		self.DIRECTORY = __title

		# remember the last directory path.
		self.GCONF_CLIENT.set_value( \
			"string", \
			Conf.SCHEMA["last-directory-path"]["key"], \
			__title \
		)

		return __title

	def exit (self) :
		self.WIDGET.feed_child("\n")
		self.WIDGET.feed_child("exit\n")

		__VTE__.egg.exit(self)

	def store_recent (self) :
		__data = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["recent-opened-directories"]["key"])

		list_directory = list()
		try :
			__data0 = base64.decodestring(__data)
			__data1 = marshal.loads(__data0)

			if type(__data1) is list :
				list_directory = __data1
		except EOFError :
			pass

		if self.DIRECTORY in list_directory :
			# remove old one and make new one be 1st.
			del(list_directory[list_directory.index(self.DIRECTORY)])

		list_directory = [self.DIRECTORY,] + list_directory

		__data = marshal.dumps(list_directory)
		__data0 = base64.encodestring(__data)

		self.GCONF_CLIENT.set_value("string", \
			Conf.SCHEMA["recent-opened-directories"]["key"], \
			__data0 \
		)

class tab (__BASIC__.tab) :

	LABEL_NAME = _("Terminal")

	def __init__ (self, state, **kwargs) :

		__BASIC__.tab.__init__(self, state, **kwargs)

	def getEgg (self) :
		# get the latest directory path.
		if not self.KWARGS.has_key("directory") :
			__dirname = \
				self.GCONF_CLIENT.get_value(Conf.SCHEMA["last-directory-path"]["key"])
			if os.path.exists(__dirname) :
				self.KWARGS["directory"] = __dirname
			else :
				__dirname = os.getenv("HOME")

		self.EGG = egg(**self.KWARGS)
		self.EGG.make()

	def make (self) :
		self.getEgg()

		self.WIDGET = TAB.TAB(state=self.STATE)
		self.WIDGET.STR_TAB_NAME = self.LABEL_NAME
		self.WIDGET.addVTE(self.EGG)

		self.append_tab()
		self.connect()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "terminal.py"


